UlduarAutoPilot = LibStub("AceAddon-3.0"):NewAddon("UlduarAutoPilot", "AceConsole-3.0", "AceEvent-3.0")
local callbacks = LibStub("CallbackHandler-1.0"):New(UlduarAutoPilot)
local L = LibStub("AceLocale-3.0"):GetLocale("UlduarAutoPilot")

local GetSubZoneText = _G.GetSubZoneText
local IsAltKeyDown = _G.IsAltKeyDown
local GetRealZoneText = _G.GetRealZoneText
local SelectGossipOption = _G.SelectGossipOption
local strlen = _G.string.len

UlduarAutoPilot.subzones = {
	[L["Expedition Base Camp"]] = 			1,		--Home
	[L["Iron Concourse"]] = 				2,		--trash before Flame Leviathan
	[L["Formation Grounds"]] = 				2,		--Flame Leviathan
	[L["The Colossal Forge"]] = 			3,		--Ignis the Furnace Master
	[L["Razorscale's Aerie"]] = 			3,		--Razorscale
	[L["The Scrapyard"]] = 					3,		--XT-002 Deconstructor
	[L["The Antechamber"]] = 				5,		--trash before Kologarn and Assembly of Iron
	[L["The Assembly of Iron"]] = 			5,		--Ferrous Collaborative
	[L["The Shattered Walkway"]] = 			5,		--Kologarn
	[L["The Celestial Planetarium"]] = 		5,		--Algalon
	[L["The Observation Ring"]] = 			6,		--Auriaya
	[L["The Halls of Winter"]] = 			6,		--Hodir
	[L["Hall of Memories"]] = 				6,		--trash before General Vezax
	[L["The Descent into Madness"]] = 		6,		--General Vezax
	[L["The Clash of Thunder"]] = 			7,		--Thorim
	[L["The Conservatory of Life"]] = 		7,		--Freya
	[L["The Corridors of Ingenuity"]] = 	7,		--trash before Mimiron
	[L["LMS Mark II"]] = 					7,		--please keep your seatback and tray table in its full upright and locked position while the train is in motion
	[L["The Spark of Imagination"]] = 		8,		--Mimiron
	[L["The Prison of Yogg-Saron"]] = 		9,  	--Possibility for anal tentacle rape = high
}

UlduarAutoPilot.teleports = {
	[1] = L["Expedition Base Camp"],
	[2] = L["Formation Grounds"],
	[3] = L["The Colossal Forge"],
	[4] = L["The Scrapyard"], 						--most worthless teleport location ever
	[5] = L["The Antechamber"],
	[6] = L["The Shattered Walkway"],
	[7] = L["The Conservatory of Life"],
	[8] = L["The Spark of Imagination"],
	[9] = L["The Descent into Madness"],
	[99] = L["UlduarAutoPilot"],					--"nil" location
}

local function triggerEvent(...)
	callbacks:Fire(...)
end

function UlduarAutoPilot:PlayerInUlduar()
	if GetRealZoneText():find(L["Ulduar"]) then return true end
	return false
end

function UlduarAutoPilot:OnInitialize()
	self.teleportlocation = 99
end

function UlduarAutoPilot:OnEnable()
	self:RegisterEvent("PLAYER_DEAD", function() self:SetTeleportLocation(GetSubZoneText()) end)
	self:RegisterEvent("GOSSIP_SHOW", "SelectTeleportGossip")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	self:RegisterEvent("ZONE_CHANGED")
	
	self.lastSubZone = ""
end

function UlduarAutoPilot:SetTeleportLocation(loc)
	if type(loc) == "number" then
		self.teleportlocation = loc --called from LDB, we're given the gossip index directly
	else --was called from PLAYER_DEAD
		if not self:PlayerInUlduar() then return end --don't allow setting on death outside Ulduar
		if strlen(loc) == 0 then
			loc = self.lastSubZone
		end
		self.teleportlocation = self.subzones[loc]
	end
	triggerEvent("UpdateDestination")
end

function UlduarAutoPilot:SelectTeleportGossip()
	if not self:PlayerInUlduar() or IsAltKeyDown() or self.teleportlocation == 99 then return end
	numGossipOptions = GetNumGossipOptions()
	if GetSubZoneText() == L["Expedition Base Camp"] then --only auto select from front entrance's teleporter
		if self.teleportlocation > numGossipOptions then
			self.teleportlocation = numGossipOptions --override invalid choice for furthest reached teleport
		end
		SelectGossipOption(self.teleportlocation)
	elseif GetSubZoneText() == L["The Scrapyard"] then
		SelectGossipOption(5) --presumably, you've just killed XT-002 and you're going to the Antechamber
	end
end

function UlduarAutoPilot:ZONE_CHANGED_NEW_AREA()
	if self:PlayerInUlduar() and self.teleportlocation < 99 then
		self:Print(self.teleports[self.teleportlocation])
	end
end

function UlduarAutoPilot:ZONE_CHANGED()
	local curSubZone = GetSubZoneText() 
	if strlen(curSubZone) > 0 then
		self.lastSubZone = curSubZone --keep a bookmark of our last zone for when we enter no man's land
	end
end
