﻿local UlduarAutoPilot = UlduarAutoPilot
local L = LibStub("AceLocale-3.0"):GetLocale("UlduarAutoPilot")

if not LibStub then return end
local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
if not ldb then return end

UlduarAutoPilot.LDB = ldb:NewDataObject("UlduarAutoPilot", {
	type = "data source",
	text = L["UlduarAutoPilot"],
	icon = "Interface\\Icons\\achievement_boss_yoggsaron_01",
})

local menu = {}
do
	for k,v in ipairs(UlduarAutoPilot.teleports) do
		local x = {
			text = v,
			func = function()
				UlduarAutoPilot:SetTeleportLocation(k)
			end,
			checked = function() return UlduarAutoPilot.teleportlocation == k end,
		}
		table.insert(menu, x)
	end
	
	table.insert(menu, {text = "", disabled = true}) --Separator
	table.insert(menu, {text = "None selected", func = function() UlduarAutoPilot:SetTeleportLocation(99) end})
end

local popupFrame = CreateFrame("Frame", "UlduarAutoPilotMenu", UIParent, "UIDropDownMenuTemplate")
function UlduarAutoPilot.LDB.OnClick(self, button)
	EasyMenu(menu, popupFrame, self, 20, 4, "MENU")
end

local function updateDisplay()
	UlduarAutoPilot.LDB.text = UlduarAutoPilot.teleports[UlduarAutoPilot.teleportlocation] or L["UlduarAutoPilot"]
end

UlduarAutoPilot.RegisterCallback(UlduarAutoPilot, "UpdateDestination", updateDisplay)
